setup-disk.in 23 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5
#!/bin/sh

PREFIX=
. "$PREFIX/lib/libalpine.sh"

6
MBR=${MBR:-"/usr/share/syslinux/mbr.bin"}
7 8
ROOTFS=${ROOTFS:-ext4}
BOOTFS=${BOOTFS:-ext4}
9
VARFS=${VARFS:-ext4}
Natanael Copa's avatar
Natanael Copa committed
10

11 12 13
# default location for mounted root
SYSROOT=${SYSROOT:-/mnt}

Natanael Copa's avatar
Natanael Copa committed
14 15 16 17 18 19 20 21 22 23
in_list() {
	local i="$1"
	shift
	while [ $# -gt 0 ]; do
		[ "$i" = "$1" ] && return 0
		shift
	done
	return 1
}

24 25 26 27 28 29 30 31 32 33 34
all_in_list() {
	local needle="$1"
	local i
	[ -z "$needle" ] && return 1
	shift
	for i in $needle; do
		in_list "$i" $@ || return 1
	done
	return 0
}

35 36 37 38 39 40 41 42
# wrapper to only show given device
_blkid() {
	blkid | grep "^$1:"
}

# if given device have an UUID display it, otherwise return the device
uuid_or_device() {
	local i=
43 44 45
	case "$1" in
		/dev/md*) echo "$1" && return 0;;
	esac
46 47 48 49 50 51 52 53 54 55 56 57 58
	for i in $(_blkid "$1"); do
		case "$i" in
			UUID=*) eval $i;;
		esac
	done
	if [ -n "$UUID" ]; then
		echo "UUID=$UUID"
	else
		echo "$1"
	fi
}

# generate an fstab from a given mountpoint. Convert to UUID if possible
59
enumerate_fstab() {
60
	local mnt="$1"
61
	local fs_spec= fs_file= fs_vfstype= fs_mntops= fs_freq= fs_passno=
62
	[ -z "$mnt" ] && return
63 64
	local escaped_mnt=$(echo $mnt | sed -e 's:/*$::' -e 's:/:\\/:g')
	awk "\$2 ~ /^$escaped_mnt(\/|\$)/ {print \$0}" /proc/mounts | \
65 66 67 68
		sed "s:$mnt:/:g; s: :\t:g" | sed 's:/\+:/:g' | \
		while read fs_spec fs_file fs_vfstype fs_mntops fs_freq fs_passno; do
			echo -e "$(uuid_or_device $fs_spec)\t${fs_file}\t${fs_vfstype}\t${fs_mntops} ${fs_freq} ${fs_passno}"
		done
69 70
}

71 72 73 74 75
is_vmware() {
	grep -q VMware /proc/scsi/scsi 2>/dev/null \
		|| grep -q VMware /proc/ide/hd*/model 2>/dev/null
}

76 77 78 79 80
# return true (0) if given device is lvm
is_lvm() {
	lvs "$1" >/dev/null 2>&1
}

81 82
# Find the disk device from given partition
disk_from_part() {
83 84
	# we need convert cciss/c0d0* cciss!c0d0*...
	local i= part=$(echo ${1#/dev/} | sed 's:/:!:g')
85 86
	for i in /sys/block/*/$part; do
		i=${i%/*}
87
		# ...and back from cciss!c0d0 to cciss/c0d0
88 89 90 91
		if [ -b "/dev/${i##*/}" ]; then
			echo "/dev/${i##*/}" | sed 's:!:/:g'
			return 0
		fi
92 93 94 95
	done
	return 1
}

96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112
unpack_apkovl() {
	local ovl="$1"
	local dest="$2"
	local suffix=${ovl##*.}
	local i
	ovlfiles=/tmp/ovlfiles
	if [ "$suffix" = "gz" ]; then
		if ! tar -C "$dest" --numeric-owner -zxvf "$ovl" > $ovlfiles; then
			echo -n "Continue anyway? [Y/n]: "
			read i
			case "$i" in
				n*|N*) return 1;;
			esac
		fi
		return 0 
	fi

113
	apk add --quiet openssl
114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130

	if ! openssl list-cipher-commands | grep "^$suffix$" > /dev/null; then
		errstr="Cipher $suffix is not supported"
		return 1
	fi
	local count=0
	# beep
	echo -e "\007"
	while [ $count -lt 3 ]; do
		openssl enc -d -$suffix -in "$ovl" | tar --numeric-owner \
			-C "$dest" -zxv >$ovlfiles 2>/dev/null && return 0
		count=$(( $count + 1 ))
	done
	ovlfiles=
	return 1
}

131 132 133 134 135 136 137 138
# find filesystem of given mounted dir
find_mount_fs() {
	local mount_point="$1"
	awk "\$2 == \"$mount_point\" {print \$3}" /proc/mounts | tail -n 1
}

# find device for given mounted dir
find_mount_dev() {
139
	local mnt="$1"
140 141 142 143
	awk "\$2 == \"$mnt\" { print \$1 }" /proc/mounts | tail -n 1
}

supported_boot_fs() {
144
	local supported="ext2 ext3 ext4 btrfs"
145 146 147 148 149 150 151 152
	local fs=
	for fs in $supported; do
		[ "$fs" = "$1" ] && return 0
	done
	echo "$1 is not supported. Only supported are: $supported" >&2
	return 1
}

153 154 155 156 157 158 159 160 161 162
find_volume_group() {
	local lv=${1##*/}
	lvs --noheadings "$1" | awk "\$1 == \"$lv\" {print \$2}"
}

find_pvs_in_vg() {
	local vg="$1"
	pvs --noheadings | awk "\$2 == \"$vg\" {print \$1}"
}

163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187
# echo current grsecurity option and set new
set_grsec() {
	local key="$1" value="$2"
	if ! [ -e /proc/sys/kernel/grsecurity/$key ]; then
		return 0
	fi
	cat /proc/sys/kernel/grsecurity/$key
	echo $value > /proc/sys/kernel/grsecurity/$key
}

init_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		mkdir -p "$mnt"/$i
		mount --bind /$i "$mnt"/$i
	done
}

cleanup_chroot_mounts() {
	local mnt="$1" i=
	for i in proc dev; do
		umount "$mnt"/$i
	done
}

188
install_mounted_root() {
Natanael Copa's avatar
Natanael Copa committed
189
	local mnt="$1" mnt_boot= boot_fs= root_fs=
190
	local initfs_features="ata base ide scsi usb virtio"
191
	local pvs= dev= rootdev= bootdev= extlinux_raidopt= root= modules=
192
	local kernel_opts="quiet"
193

194
	rootdev=$(find_mount_dev "$mnt")
195 196 197 198
	if [ -z "$rootdev" ]; then
		echo "$mnt does not seem to be a mount point" >&2
		return 1
	fi
199
	root_fs=$(find_mount_fs "$mnt")
200 201 202 203
	initfs_features="$initfs_features $root_fs"

	if is_lvm "$rootdev"; then
		initfs_features="$initfs_features lvm"
204 205
		local vg=$(find_volume_group "$rootdev")
		pvs=$(find_pvs_in_vg $vg)
206 207
	fi

208

209 210 211
	bootdev=$(find_mount_dev "$mnt"/boot)
	if [ -z "$bootdev" ]; then
		bootdev=$rootdev
Natanael Copa's avatar
Natanael Copa committed
212
		mnt_boot="$mnt"
213 214 215 216 217 218
	else
		mnt_boot="$mnt"/boot
	fi
	boot_fs=$(find_mount_fs "$mnt_boot")
	supported_boot_fs "$boot_fs" || return 1

219 220
	# Check if we boot from raid so we can pass proper option to
	# extlinux later.
221
	if [ -e "/sys/block/${bootdev#/dev/}/md" ]; then
222
		extlinux_raidopt="--raid"
223
	fi
224

225 226
	# check if our root is on raid so we can feed mkinitfs and
	# update-exlinux.conf with the proper kernel module params
227 228 229 230
	for dev in $rootdev $pvs; do
		[ -e "/sys/block/${dev#/dev/}/md" ] || continue

		local md=${dev#/dev/}
231
		initfs_features="${initfs_features% raid} raid"
232 233
		local level=$(cat /sys/block/$md/md/level)
		case "$level" in
234 235
			raid1) raidmod="${raidmod%,raid1},raid1";;
			raid[456]) raidmod="${raidmod%,raid456},raid456";;
236 237
		esac
	done
238 239 240 241

	# check if we need hardware raid drivers
	case $rootdev in
		/dev/cciss/*)
242
			initfs_features="${initfs_features% raid} raid"
243 244 245
			;;
	esac

246 247 248 249 250 251
	if [ -n "$VERBOSE" ]; then
		echo "Root device:     $rootdev"
		echo "Root filesystem: $root_fs"
		echo "Boot device:     $bootdev"
		echo "Boot filesystem: $boot_fs"
	fi
252

253
	if [ -z "$APKOVL" ]; then
254 255
		ovlfiles=/tmp/ovlfiles
		lbu package - | tar -C "$mnt" -zxv > "$ovlfiles"
256 257
	else
		echo "Restoring backup from $APKOVL to $rootdev..."
258
		unpack_apkovl "$APKOVL" "$mnt" || return 1
259
	fi
260

261
	# generate mkinitfs.conf
262
	mkdir -p "$mnt"/etc/mkinitfs/files.d
263
	echo "features=\"$initfs_features\"" > "$mnt"/etc/mkinitfs/mkinitfs.conf
264 265 266 267
	if [ -n "$raidmod" ]; then
		echo "/sbin/mdadm" > "$mnt"/etc/mkinitfs/files.d/raid
		echo "/etc/mdadm.conf" >> "$mnt"/etc/mkinitfs/files.d/raid
	fi
268

269 270 271 272 273 274 275 276 277 278
	# generate update-extlinux.conf
	root=$(uuid_or_device $rootdev)
	if is_vmware; then
		kernel_opts="pax_nouderef $kernel_opts"
	fi
	modules="sd-mod,usb-storage,${root_fs}${raidmod}"
	sed -e "s:^root=.*:root=$root:" \
		-e "s:^default_kernel_opts=.*:default_kernel_opts=\"$kernel_opts\":" \
		-e "s:^modules=.*:modules=$modules:" \
		/etc/update-extlinux.conf > "$mnt"/etc/update-extlinux.conf
279 280 281 282
	if [ "$(rc --sys)" = "XEN0" ]; then
		sed -i -e "s:^default=.*:default=xen-grsec:" \
			"$mnt"/etc/update-extlinux.conf
	fi
283

284 285 286 287 288 289 290 291 292 293
	# generate the fstab
	if [ -f "$mnt"/etc/fstab ]; then
		mv "$mnt"/etc/fstab "$mnt"/etc/fstab.old
	fi
	enumerate_fstab "$mnt" >> "$mnt"/etc/fstab
	cat >>"$mnt"/etc/fstab <<EOF
/dev/cdrom	/media/cdrom	iso9660	noauto,ro 0 0
/dev/fd0	/media/floppy	vfat	noauto	0 0
/dev/usbdisk	/media/usb	vfat	noauto	0 0
EOF
294
	# remove the installed db in case its there so we force re-install
295
	rm -f "$mnt"/var/lib/apk/installed "$mnt"/lib/apk/db/installed
296
	echo "Installing system on $rootdev:"
297 298
	extlinux $extlinux_raidopt --install "$mnt"/boot

299 300 301 302
	# apk reads config from target root so we need to copy the config
	mkdir -p "$mnt"/etc/apk/keys/
	cp /etc/apk/keys/* "$mnt"/etc/apk/keys/

303
	local apkflags="--initdb --quiet --progress --update-cache --clean-protected"
304
	local pkgs=$(cat "$mnt"/etc/apk/world "$mnt"/var/lib/apk/world 2>/dev/null)
305
	pkgs="$pkgs acct linux-$KERNEL_FLAVOR alpine-base"
306 307 308
	if [ "$(rc --sys)" = "XEN0" ]; then
		pkgs="$pkgs xen-hypervisor"
	fi
309 310 311 312 313
	local repos=$(sed -e 's/\#.*//' /etc/apk/repositories)
	local repoflags=
	for i in $repos; do
		repoflags="$repoflags --repository $i"
	done
314
	
315 316
	chroot_caps=$(set_grsec chroot_caps 0)
	init_chroot_mounts "$mnt"
317
	apk add --root "$mnt" $apkflags --overlay-from-stdin \
318 319 320 321 322
		$repoflags $pkgs <$ovlfiles>/dev/null
	local ret=$?
	cleanup_chroot_mounts "$mnt"
	set_grsec chroot_caps $chroot_caps > /dev/null
	return $ret
323 324 325 326
}

unmount_partitions() {
	local mnt="$1"
327 328

	# unmount the partitions
Natanael Copa's avatar
Natanael Copa committed
329
	umount $(awk '{print $2}' /proc/mounts | egrep "^$mnt(/|\$)" | sort -r)
330
}
331

332 333 334
# figure out decent default swap size in mega bytes
find_swap_size() {
	local memtotal_kb=$(awk '$1 == "MemTotal:" {print $2}' /proc/meminfo)
335 336 337 338
	# use 2 * avaiable ram or no more than 1/3 of smallest disk space
	local size=$(( $memtotal_kb * 2 / 1024 ))
	local disk= disksize=
	for disk in $@; do
339 340
		local sysfsdev=$(echo ${disk#/dev/} | sed 's:/:!:g')
		local sysfspath=/sys/block/$sysfsdev/size
341 342 343 344 345 346 347 348 349 350 351 352 353 354 355
		# disksize = x * 512 / (1024 * 1024) = x / 2048
		# maxsize = $disksize / 4 = x / (2048 * 4) = x / 8192
		maxsize=$(awk '{ printf "%i", $0 / 8192 }' $sysfspath )
		if [ $size -gt $maxsize ]; then
			size=$maxsize
		fi
	done
	if [ $size -gt 4096 ]; then
		# dont ever use more than 4G
		size=4096
	elif [ $size -lt 64 ]; then
		# dont bother create swap smaller than 64MB
		size=0
	fi
	echo $size
356 357 358 359
}

has_mounted_part() {
	local p
360
	local sysfsdev=$(echo ${1#/dev/} | sed 's:/:!:g')
Natanael Copa's avatar
Natanael Copa committed
361
	# parse /proc/mounts for mounted devices
362
	for p in $(awk '$1 ~ /^\/dev\// {gsub("/dev/", "", $1); gsub("/", "!", $1); print $1}' \
363
			/proc/mounts); do
364 365
		[ "$p" = "$sysfsdev" ] && return 0
		[ -e /sys/block/$sysfsdev/$p ] && return 0
366 367 368 369
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389
has_holders() {
	local i
	# check if device is used by any md devices
	for i in $1/holders/* $1/*/holders/*; do
		[ -e "$i" ] && return 0
	done
	return 1
}

is_available_disk() {
	local dev=$1
	local b=$(echo $p | sed 's:/:!:g')

	# check if its a "root" block device and not a partition
	[ -e /sys/block/$b ] || return 1
	
	# check so it does not have mounted partitions
	has_mounted_part $dev && return 1

	# check so its not part of an md setup
390 391 392 393
	if has_holders /sys/block/$b; then
		[ -n "$USE_RAID" ] && echo "Warning: $dev is part of a running raid" >&2
		return 1
	fi
Natanael Copa's avatar
Natanael Copa committed
394 395 396 397 398 399 400

	# check so its not an md device
	[ -e /sys/block/$b/md ] && return 1

	return 0
}

401
find_disks() {
Natanael Copa's avatar
Natanael Copa committed
402
	local p=
403
	for p in $(awk '$1 ~ /[0-9]+/ {print $4}' /proc/partitions); do
Natanael Copa's avatar
Natanael Copa committed
404
		is_available_disk $p && echo -n " $p"
405 406 407
	done
}

408 409 410 411 412 413 414 415 416 417 418
stop_all_raid() {
	local rd
	for rd in /dev/md*; do
		[ -b $rd ] && mdadm --stop $rd
	done
}

# install needed programs
init_progs() {
	local raidpkg=
	[ -n "$USE_RAID" ] && raidpkg="mdadm"
419
	apk add --quiet sfdisk e2fsprogs lvm2 $raidpkg syslinux $@
420 421
}

422
show_disk_info() {
Natanael Copa's avatar
Natanael Copa committed
423
	local disk= vendor= model= d= size=
424
	for disk in $@; do
425 426
		local dev=${disk#/dev/}
		d=$(echo $dev | sed 's:/:!:g')
427 428 429
		vendor=$(cat /sys/block/$d/device/vendor 2>/dev/null)
		model=$(cat /sys/block/$d/device/model 2>/dev/null)
		size=$(awk '{gb = ($1 * 512)/1000000000; printf "%.1f GB\n", gb}' /sys/block/$d/size 2>/dev/null)
430
		echo "  $dev	($size $vendor $model)"
431 432
	done
}
433

434 435
confirm_erase() {
	local answer=
436
	echo "WARNING: The following disk(s) will be erased:"
437
	show_disk_info $@
438
	echo -n "WARNING: Erase the above disk(s) and continue? [y/N]: "
439
	
440 441
	read answer
	case "$answer" in
442
		y*|Y*) return 0;;
443
	esac
444
	return 1
445 446
}

447
# setup partitions on given disk dev in $1.
448 449 450 451 452 453
# usage: setup_partitions <diskdev> size1,type1 [size2,type2 ...] 
setup_partitions() {
	local diskdev="$1"
	shift

	echo "Initializing partitions on $diskdev..."
454 455 456 457 458 459 460

	# new disks does not have an DOS signature in sector 0
	# this makes sfdisk complain. We can workaround this by letting
	# fdisk create that DOS signature, by just do a "w", a write.
	# http://bugs.alpinelinux.org/issues/show/145
	echo "w" | fdisk $diskdev >/dev/null

461 462 463
	# fix the MBR while here so extlinux can boot
	cat "$MBR" > $diskdev

464 465
	local start=0
	local line=
466 467
	# create new partitions
	(
468 469 470 471
		for line in "$@"; do
			echo "$start,$line"
			start=
		done
472
	) | sfdisk -q -L -uM $diskdev >/dev/null || return 1
473 474 475 476 477 478 479 480 481 482 483

	# create device nodes if not exist
	mdev -s
}

# find the bootable partition on given disk
find_boot_partition() {
	sfdisk -d $1 | awk '/bootable/ {print $1}'
}

# find the partition(s) for LVM
484
# this is not marked as bootable and is type 8e
485 486 487 488 489
find_lvm_partition() {
	local type=8e
	sfdisk -d $1 | grep -v bootable | awk "/Id=$type/ {print \$1}"
}

490
# set up optional raid and create filesystem on boot device.
491
setup_boot_dev() {
492 493 494 495
	local disk= bootdev=
	local part=$(for disk in $@; do find_boot_partition $disk; done)
	set -- $part
	bootdev=$1
496
	[ -z "$bootdev" ] && return 1
497
	echo "Creating file systems..."
498
	if [ -n "$USE_RAID" ]; then
499 500 501 502 503 504
		local missing=
		local num=$#
		if [ $# -eq 1 ]; then
			missing="missing"
			num=2
		fi
505
		# we only use raid level 1 for boot devices
506 507
		mdadm --create /dev/md0 --level=1 --raid-devices=$num \
			--metadata=0.90 --quiet --run $@ $missing || return 1
508 509
		bootdev=/dev/md0
	fi
510
	mkfs.$BOOTFS -q $bootdev
511 512 513 514
	BOOT_DEV="$bootdev"
}

# $1 = index
515 516 517
# $2 = partition type
# $3... = disk devices
find_nth_non_boot_parts() {
518
	local idx=$1
519
	local id=$2
520 521
	local disk=
	shift
522
	shift
523 524
	for disk in $@; do
		sfdisk -d $disk | grep -v bootable \
525
			| awk "/Id=$id/ { i++; if (i==$idx) print \$1 }"
526 527 528 529 530 531 532 533 534
	done
}

setup_non_boot_raid_dev() {
	local md_dev=$1
	local idx=${md_dev#/dev/md}
	shift
	local level=1
	local missing=
535
	local raid_parts=$(find_nth_non_boot_parts $idx "fd" $@)
536 537 538 539 540 541 542 543 544 545
	set -- $raid_parts
	# how many disks do we have?
	case $# in
		0) echo "No Raid partitions found" >&2; return 1;;
		1) level=1; missing="missing"; num=2;;
		2) level=1; missing=  ; num=2;;
		*) level=5; missing=  ; num=$#;;
	esac
	mdadm --create /dev/md$idx --level=$level --raid-devices=$num \
		--quiet --run $@ $missing || return 1
546 547 548 549
}

# setup device for lvm, create raid array if needed
setup_lvm_volume_group() {
550 551 552
	local vgname="$1"
	shift
	local lvmdev=
553 554

	if [ -n "$USE_RAID" ]; then
555 556 557 558
		setup_non_boot_raid_dev /dev/md1 $@ || return 1
		lvmdev=/dev/md1
	else	
		lvmdev=$(find_lvm_partition $1)
559 560 561 562 563
	fi

	# be quiet on success
	local errmsg=$(dd if=/dev/zero of=$lvmdev bs=1k count=1 2>&1) \
		|| echo "$errmsg"
564 565 566 567 568 569 570 571 572 573 574 575 576 577
	pvcreate --quiet $lvmdev \
		&& vgcreate --quiet $vgname $lvmdev >/dev/null
}

# set up swap on given device(s)
setup_swap_dev() {
	local swap_dev=
	sed -i -e '/swap/d' /etc/fstab
	for swap_dev in "$@"; do
		mkswap $swap_dev >/dev/null
		echo -e "$swap_dev\tswap\t\tswap\tdefaults 0 0" >> /etc/fstab
	done
	swapon -a
	rc-update --quiet add swap boot
578 579 580
}

# setup and enable swap on given volumegroup if needed
581
setup_lvm_swap() {
582
	local vgname="$1"
583
	local swapname=lv_swap
584 585 586
	if [ -z "$SWAP_SIZE" ] || [ "$SWAP_SIZE" -eq 0 ]; then
		return
	fi
587 588
	lvcreate --quiet -n $swapname -L ${SWAP_SIZE}MB $vgname
	setup_swap_dev /dev/$vgname/$swapname
589 590 591 592 593 594 595 596 597 598
}

# if /var is mounted, move out data and umount it
reset_var() {
	[ -z "$(find_mount_dev /var)" ] && return 0
	mkdir /.var
	mv /var/* /.var/ 2>/dev/null
	umount /var && 	rm -rf /var && mv /.var /var && rm -rf /var/lost+found
}

599 600 601
# set up /var on given device
setup_var() {
	local var_dev="$1"
602
	local varfs=${VARFS}
603
	echo "Creating file systems..."
604 605 606 607 608 609 610 611 612 613 614
	mkfs.$varfs -q $var_dev >/dev/null || return 1
	sed -i -e '/[[:space:]]\/var[[:space:]]/d' /etc/fstab
	echo -e "${var_dev}\t/var\t\t${varfs}\tdefaults 1 2" >> /etc/fstab

	mv /var /.var
	mkdir /var
	mount /var
	mv /.var/* /var/
	rmdir /.var

	/etc/init.d/syslog --quiet restart
615
	setup_mdadm_conf
616 617
}

618
setup_mdadm_conf() {
619
	local mods= mod=
620 621 622
	if [ -n "$USE_RAID" ]; then
		mdadm --detail --scan > /etc/mdadm.conf
		rc-update --quiet add mdadm-raid boot
623 624 625 626 627 628
		mods=$(awk '/^raid/ {print $1}' /proc/modules)
		for mod in $mods; do
			if ! grep -q "^$mod" /etc/modules; then
				echo $mod >> /etc/modules
			fi
		done
629 630 631
	fi
}

632
data_only_disk_install_lvm() {
633
	local diskdev=
634 635
	local vgname=vg0
	local var_dev=/dev/$vgname/lv_var
636 637 638
	local lvm_part_type="8e"
	local part_type=$lvm_part_type
	local size=
639 640

	init_progs || return 1
641
	confirm_erase $@ || return 1
642

643
	if [ "$USE_RAID" ]; then
644 645
		# the paritition type for raid is "fd"
		part_type="fd"
646 647
		stop_all_raid
	fi
648

649 650 651 652 653 654
	for diskdev in "$@"; do
		setup_partitions $diskdev "$size,$part_type" || return 1
	done
	
	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
655
	lvcreate --quiet -n ${var_dev##*/} -l 100%FREE $vgname
656
	setup_mdadm_conf
Natanael Copa's avatar
Natanael Copa committed
657
	rc-update add lvm boot
658
	setup_var $var_dev
659 660
}

661 662
data_only_disk_install() {
	local diskdev=
663 664
	local var_dev=
	local var_part_type="83"
665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696
	local swap_part_type=82
	local size=
	local swap_dev= var_dev=

	init_progs || return 1
	confirm_erase $@ || return 1

	if [ "$USE_RAID" ]; then
		var_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi

	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$SWAP_SIZE,$swap_part_type" \
			"$size,$var_part_type" || return 1
	done

	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		var_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		var_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_var $var_dev
}

697 698 699 700
# setup 
setup_root() {
	local root_dev="$1" boot_dev="$2"
	mkfs.$ROOTFS -q "$root_dev"
701 702
	mkdir -p "$SYSROOT"
	mount -t $ROOTFS $root_dev "$SYSROOT" || return 1
703
	if [ -n "$boot_dev" ]; then
704 705
		mkdir -p "$SYSROOT"/boot
		mount -t $BOOTFS $boot_dev "$SYSROOT"/boot || return 1
706 707 708
	fi

	setup_mdadm_conf
709 710
	install_mounted_root "$SYSROOT" || return 1
	unmount_partitions "$SYSROOT"
711 712 713
	swapoff -a

	echo ""
714
	echo "Installation is complete. Please reboot."
715 716
}

717
native_disk_install_lvm() {
718 719 720 721 722 723 724
	local diskdev= vgname=vg0
	local lvm_part_type="8e"
	local boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local lvm_size=
	local root_dev=/dev/$vgname/lv_root

725
	init_progs || return 1
726
	confirm_erase $@ || return 1
727 728

	if [ -n "$USE_RAID" ]; then
729 730 731
		boot_part_type="fd"
		lvm_part_type="fd"
		stop_all_raid
732
	fi
733 734 735 736 737 738 739 740 741 742 743 744
	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$boot_size,$boot_part_type,*" \
			"$lvm_size,$lvm_part_type" || return 1
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@

	setup_lvm_volume_group $vgname $@ || return 1
	setup_lvm_swap $vgname
	lvcreate --quiet -n ${root_dev##*/} -l 100%FREE $vgname
Natanael Copa's avatar
Natanael Copa committed
745
	rc-update add lvm boot
746
	setup_root $root_dev $BOOT_DEV
Natanael Copa's avatar
Natanael Copa committed
747 748
}

749 750 751 752 753 754 755
native_disk_install() {
	local root_part_type="83" swap_part_type="82" boot_part_type="83"
	local boot_size=${BOOT_SIZE:-100}
	local swap_size=${SWAP_SIZE}
	local root_size=
	local root_dev= boot_dev= swap_dev=

756
	init_progs || return 1
757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788
	confirm_erase $@ || return 1

	if [ -n "$USE_RAID" ]; then
		boot_part_type="fd"
		root_part_type="fd"
		swap_part_type="fd"
		stop_all_raid
	fi
	for diskdev in "$@"; do
		setup_partitions $diskdev \
			"$boot_size,$boot_part_type,*" \
			"$swap_size,$swap_part_type" \
			"$root_size,$root_part_type" \
			|| return 1
	done

	# will find BOOT_DEV for us
	setup_boot_dev $@
	
	if [ "$USE_RAID" ]; then
		[ $SWAP_SIZE -gt 0 ] && setup_non_boot_raid_dev /dev/md1 $@
		setup_non_boot_raid_dev /dev/md2 $@ || return 1
		swap_dev=/dev/md1
		root_dev=/dev/md2
	else
		swap_dev=$(find_nth_non_boot_parts 1 82 $@)
		root_dev=$(find_nth_non_boot_parts 1 83 $@)
	fi
	[ $SWAP_SIZE -gt 0 ] && setup_swap_dev $swap_dev
	setup_root $root_dev $BOOT_DEV
}

789
diskselect_help() {
790 791
	cat <<__EOF__

Natanael Copa's avatar
Natanael Copa committed
792
The disk you select can be used for a traditional disk install or for a
793 794 795 796
data-only install.

The disk will be erased.

Natanael Copa's avatar
Natanael Copa committed
797
Enter 'none' if you want to run diskless.
798 799 800 801

__EOF__
}

802
diskmode_help() {
803 804
	cat <<__EOF__

805
You can select between 'sys' or 'data'.
806

Natanael Copa's avatar
Natanael Copa committed
807 808 809 810 811
sys:
  This mode is a traditional disk install. The following partitions will be
  created on the disk: /boot, / (filesystem root) and swap.
    
  This mode may be used for development boxes, desktops, virtual servers, etc.
812

Natanael Copa's avatar
Natanael Copa committed
813 814 815
data:
  This mode uses your disk(s) for data storage, not for the operating system.
  The system itself will run from tmpfs (RAM).
816

Natanael Copa's avatar
Natanael Copa committed
817 818
  Use this mode if you only want to use the disk(s) for a mailspool, databases,
  logs, etc.
819 820 821 822 823 824 825 826 827

__EOF__
}

# ask for a root or data disk
# returns answer in global variable $answer
ask_disk() {
	local prompt="$1"
	local help_func="$2"
828
	local i=
829 830
	shift 2
	answer=
831
	local default_disk=${DEFAULT_DISK:-$1}
832

833 834 835
	while ! all_in_list "$answer" $@ "none" "abort"; do
		echo "Available disks are:"
		show_disk_info "$@"
836 837
		echon "$prompt [$default_disk] "
		default_read answer $default_disk
838 839 840 841
		case "$answer" in
			'abort') exit 0;;
			'none') return 0;;
			'?') $help_func;;
842 843 844 845 846 847
			*) for i in $answer; do
				if ! [ -b "/dev/$i" ]; then
					echo "/dev/$i is not a block device" >&2
					answer=
				   fi
			done;;
848 849 850 851
		esac
	done
}

852 853
usage() {
	cat <<__EOF__
854
usage: setup-disk [-hLqrv] [-k kernelflavor] [-m MODE] [-o apkovl] [-s SWAPSIZE]
855 856 857 858 859 860 861 862 863 864 865 866 867
		  [MOUNTPOINT | DISKDEV...]

Install alpine on harddisk.

If MOUNTPOINT is specified, then do a traditional disk install with MOUNTPOINT
as root.

If DISKDEV is specified, then use the specified disk(s) without asking. If
multiple disks are specified then set them up in a RAID array. If there are
mode than 2 disks, then use raid level 5 instead of raid level 1.

options:
 -h  Show this help
868
 -m  Use disk for MODE without asking, where MODE is either 'data' or 'sys'
869 870
 -o  Restore system from given apkovl file
 -k  Use kernelflavor instead of $KERNEL_FLAVOR
871
 -L  Use LVM to manage partitions
872 873
 -q  Exit quietly if no disks are found
 -r  Enable software raid1 with single disk
874
 -s  Use SWAPSIZE MB instead of autodetecting swap size (Use 0 to disable swap)
875
 -v  Be more verbose about what is happening
876

877 878 879 880
__EOF__
	exit 1
}

881 882 883
KERNEL_FLAVOR=grsec
case "$(uname -r)" in
	*-vs[0-9]*) KERNEL_FLAVOR=vserver;;
884
	*-pae) KERNEL_FLAVOR=pae;;
885 886
esac

887
DISK_MODE=
888
USE_LVM=
889
# Parse args
890
while getopts "hk:Lm:o:qrs:v" opt; do
891
	case $opt in
892
		m) DISK_MODE="$OPTARG";;
893
		k) KERNEL_FLAVOR="$OPTARG";;
894
		L) USE_LVM="_lvm";;
895
		o) APKOVL="$OPTARG";;
896 897
		q) QUIET=1;;
		r) USE_RAID=1;;
898
		s) SWAP_SIZE="$OPTARG";;
899
		v) VERBOSE=1;;
Natanael Copa's avatar
Natanael Copa committed
900
		*) usage;;
901 902
	esac
done
903
shift $(( $OPTIND - 1))
904

905 906
if [ -d "$1" ]; then
	# install to given mounted root
907
	apk add --quiet syslinux
908 909
	install_mounted_root "${1%/}" \
		&& echo "You might need fix the MBR to be able to boot" >&2
910 911 912
	exit $?
fi

913 914 915 916 917 918 919 920 921 922
reset_var
swapoff -a

# stop all volume groups in use
vgchange --ignorelockingfailure -a n >/dev/null 2>&1

if [ -n "$USE_RAID" ]; then
	stop_all_raid
fi

923
disks=$(find_disks)
924
diskdevs=
Natanael Copa's avatar
Natanael Copa committed
925 926

# no disks so lets exit quietly.
927 928 929 930
if [ -z "$disks" ]; then
	[ -z "$QUIET" ] && echo "No disks found." >&2
	exit 0
fi
Natanael Copa's avatar
Natanael Copa committed
931

932 933 934 935 936
if [ $# -gt 0 ]; then
	# check that they are 
	for i in "$@"; do
		j=$(readlink -f "$i" | sed 's:^/dev/::; s:/:!:g')
		if ! [ -e "/sys/block/$j/device" ]; then
Natanael Copa's avatar
Natanael Copa committed
937
			echo "$i is not a suitable for partitioning"
938 939
			exit 1
		fi
940
		diskdevs="$diskdevs /dev/$j"
941 942
	done
else
943
	ask_disk "Which disk(s) would you like to use? (or '?' for help or 'none')" \
944
		diskselect_help $disks
945
	if [ "$answer" != none ]; then
946 947 948
		for i in $answer; do
			diskdevs="$diskdevs /dev/$i"
		done
949 950
	else
		DISK_MODE="none"
951
	fi
952
fi
Natanael Copa's avatar
Natanael Copa committed
953

954
if [ -n "$diskdevs" ] && [ -z "$DISK_MODE" ]; then
955
	answer=
956
	disk_is_or_disks_are="disk is"
957
	it_them="it"
958
	set -- $diskdevs
959
	if [ $# -gt 1 ]; then
960
		disk_is_or_disks_are="disks are"
961 962 963
		it_them="them"
	fi
		
964
	while true; do
965
		echo "The following $disk_is_or_disks_are selected:"
966
		show_disk_info $diskdevs
967
		echon "How would you like to use $it_them? ('sys', 'data' or '?' for help) [?] "
968 969 970
		default_read answer '?'
		case "$answer" in
		'?') diskmode_help;;
971
		sys|data) break;;
972 973
		esac
	done
974
	DISK_MODE="$answer"
975
fi
Natanael Copa's avatar
Natanael Copa committed
976

977 978 979 980
if [ -z "$SWAP_SIZE" ]; then
	SWAP_SIZE=$(find_swap_size $diskdevs)
fi

981 982 983 984
set -- $diskdevs
if [ $# -gt 1 ]; then
	USE_RAID=1
fi
985

986 987
dmesg -n1

988
# native disk install
989
case "$DISK_MODE" in
990
sys) native_disk_install$USE_LVM $diskdevs;;
991
data) data_only_disk_install$USE_LVM $diskdevs;;
992
none) exit 0;;
993
*) echo "Not a valid install mode: $DISK_MODE" >&2; exit 1;;
994
esac
Natanael Copa's avatar
Natanael Copa committed
995

996
echo "$DISK_MODE" > /tmp/alpine-install-diskmode.out